#ifndef EMPRESTIMO_H
#define EMPRESTIMO_H

#include "livro.h" // Inclui o cabeçalho do tipo Livro

#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#define MAX_UTILIZADOR 100 // Define o tamanho máximo para o nome do utilizador
#define MAX_TITULO_LIVRO 100 // Define o tamanho máximo para o título do livro

// Definição da estrutura Emprestimo
typedef struct {
    char utilizador[MAX_UTILIZADOR]; // Nome do utilizador que realizou o empréstimo
    char tituloLivro[MAX_TITULO_LIVRO]; // Título do livro emprestado
    int diasEmprestimo; // Número de dias do empréstimo
    int dataDevolucao; // Data prevista para devolução do livro
    int devolvido; // Flag indicando se o livro foi devolvido ou não
} Emprestimo;

// Funções relacionadas a empréstimos
void registrarEmprestimo(Emprestimo **registos, int *numRegistos, Livro *biblioteca, int numLivros);
void removerEmprestimo(Emprestimo *registos, int *numRegistos);
void listarEmprestimosAtivos(Emprestimo *registos, int numRegistos);
void lerEmprestimos(const char *nomeArquivo, Emprestimo **registos, int *numRegistos);
void gravarEmprestimos(const char *nomeArquivo, Emprestimo *registos, int numRegistos);

#endif /* EMPRESTIMO_H */
