#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <time.h>

#include "livro.h"
#include "emprestimo.h"
#include "relatorio.h"
#include "pesquisa.h"
#include "time.h"

#define MAX_LIVROS 100
#define MAX_EMPRESTIMOS 1000

int main() {  
    // Declaração das variáveis
    Livro *biblioteca = NULL;
    int numLivros = 0;

    Emprestimo *registos = NULL;
    int numRegistos = 0;

    // Obtenção da data atual
    int dataAtual = getDataAtual(); // Obter a data atual

    // Carregamento dos dados dos livros e empréstimos dos arquivos CSV
    lerLivros("livros.csv", &biblioteca, &numLivros);
    lerEmprestimos("emprestimos.csv", &registos, &numRegistos);
  
    // Menu principal
    int opcao;
    do {
        printf("\n\nMenu:\n");
        printf("1. Adicionar livro\n");
        printf("2. Remover livro\n");
        printf("3. Editar livro\n");
        printf("4. Pesquisar livro\n");
        printf("5. Registrar Empréstimo\n");
        printf("6. Devolver Empréstimo\n");
        printf("7. Listar Empréstimos Ativos\n");
        printf("8. Relatório dos 10 Livros Mais Emprestados\n");
        printf("9. Relatório dos Livros Não Devolvidos\n");
        printf("10. Relatório dos 10 Utilizadores com Mais Empréstimos\n");
        printf("11. Sair\n");
        printf("Escolha uma opção: ");
        scanf("%d", &opcao);

        switch (opcao) {
            case 1:
                adicionarLivro(&biblioteca, &numLivros);
                break;
            case 2:
                removerLivro(&biblioteca, &numLivros);
                break;
            case 3:
                editarLivro(biblioteca, numLivros);
                break;
            case 4:
                pesquisarLivro(biblioteca, numLivros, registos, numRegistos);
                break;
            case 5:
                registrarEmprestimo(&registos, &numRegistos, biblioteca, numLivros);
                break;
            case 6:
                removerEmprestimo(registos, &numRegistos);
                break;
            case 7:
                listarEmprestimosAtivos(registos, numRegistos);
                break;
            case 8:
                relatorioLivrosMaisEmprestados(registos, numRegistos, biblioteca, numLivros);
                break;
            case 9:
                relatorioLivrosNaoDevolvidos(registos, numRegistos, biblioteca, numLivros, dataAtual);
                break;
            case 10:
                relatorioUtilizadoresMaisEmprestimos(registos, numRegistos);
                break;
            case 11:
                gravarLivros("livros.csv", biblioteca, numLivros);
                gravarEmprestimos("emprestimos.csv", registos, numRegistos);
                break;
            default:
                printf("Opção inválida! Tente novamente.\n");
        }
    } while (opcao != 11);

    // Liberação da memória alocada
    free(biblioteca); // Liberar memória alocada para a biblioteca de livros
    free(registos); // Liberar memória alocada para os registros de empréstimo

    return 0;
}